DCMTK: DcmMetaInfo Class Reference

DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Private Member Functions | Private Attributes | List of all members
DcmMetaInfo Class Reference

a class representing the DICOM file meta information header More...

Inheritance diagram for DcmMetaInfo:

## Public Member Functions
| DcmMetaInfo ()
| default constructor
| DcmMetaInfo (const DcmMetaInfo &old)
| copy constructor
DcmMetaInfo & | operator= (const DcmMetaInfo &obj)
| assignment operator.
virtual | ~DcmMetaInfo ()
| destructor
virtual DcmObject * | clone () const
| clone method
virtual OFCondition | copyFrom (const DcmObject &rhs)
| Virtual object copying.
virtual DcmEVR | ident () const
| get type identifier
virtual void | removeInvalidGroups ()
| remove all elements with an invalid group number, i.e.
E_TransferSyntax | getOriginalXfer () const
| return the transfer syntax in which this dataset was originally read.
virtual void | print (STD_NAMESPACE ostream &out, const size_t flags=0, const int level=0, const char *pixelFileName=NULL, size_t *pixelCounter=NULL)
| print meta information header to a stream
virtual void | transferInit ()
| initialize the transfer state of this object.
virtual void | transferEnd ()
| finalize the transfer state of this object.
virtual Uint32 | calcElementLength (const E_TransferSyntax xfer, const E_EncodingType enctype)
| calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.
virtual OFCondition | read (DcmInputStream &inStream, const E_TransferSyntax xfer=EXS_Unknown, const E_GrpLenEncoding glenc=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength)
| read object from a stream.
virtual OFCondition | write (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| write meta information header to a stream
virtual OFCondition | writeXML (STD_NAMESPACE ostream &out, const size_t flags=0)
| write object in XML format
virtual OFCondition | writeJson (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write object in JSON format
virtual OFCondition | loadFile (const OFFilename &fileName, const E_TransferSyntax readXfer=EXS_Unknown, const E_GrpLenEncoding groupLength=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength)
| load object from a DICOM file.
virtual const char * | getPreamble () const
| access the file preamble after reading a DICOM file.
Public Member Functions inherited from DcmItem
| DcmItem ()
| default constructor
| DcmItem (const DcmTag &tag, const Uint32 len=0)
| constructor.
| DcmItem (const DcmItem &old)
| copy constructor
DcmItem & | operator= (const DcmItem &obj)
| assignment operator.
virtual int | compare (const DcmItem &rhs) const
| comparison operator that compares the value of this object with a given object of the same type.
virtual | ~DcmItem ()
| destructor
virtual unsigned long | getVM ()
| get value multiplicity
virtual unsigned long | getNumberOfValues ()
| get number of values (elements) stored in this item.
virtual unsigned long | card () const
| get cardinality of this item
virtual OFBool | isLeaf () const
| check if this element is a leaf node in a dataset tree.
virtual OFBool | isNested () const
| check if this item is nested in a sequence of items, i.e. not a top-level or stand-alone item/dataset
virtual Uint32 | getLength (const E_TransferSyntax xfer=EXS_LittleEndianImplicit, const E_EncodingType enctype=EET_UndefinedLength)
| calculate the value length (without attribute tag, VR and length field) of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.
virtual DcmItem * | getParentItem ()
| get parent item of this object, i.e. the item/dataset in which the surrounding sequence element is stored.
virtual OFBool | canWriteXfer (const E_TransferSyntax newXfer, const E_TransferSyntax oldXfer)
| check if this DICOM object can be encoded in the given transfer syntax.
virtual OFCondition | readUntilTag (DcmInputStream &inStream, const E_TransferSyntax ixfer, const E_GrpLenEncoding glenc=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength, const DcmTagKey &stopParsingAtElement=DCM_UndefinedTagKey)
| This function reads the information of all attributes which are captured in the input stream and captures this information in elementList, up to the attribute tag stopParsingAtElement.
virtual OFCondition | writeJsonExt (STD_NAMESPACE ostream &out, DcmJsonFormat &format, OFBool printBraces, OFBool printNewline)
| write object in JSON format and control whether the output is encapsulated in braces
virtual OFCondition | writeSignatureFormat (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| special write method for creation of digital signatures
virtual OFBool | containsUnknownVR () const
| returns true if the object contains an element with Unknown VR at any nesting level
virtual OFBool | containsExtendedCharacters (const OFBool checkAllStrings=OFFalse)
| check if this object contains non-ASCII characters at any nesting level.
virtual OFBool | isAffectedBySpecificCharacterSet () const
| check if this object is affected by SpecificCharacterSet at any nesting level.
virtual OFBool | checkForSpecificCharacterSet () const
| mode specifying whether the SpecificCharacterSet (0008,0005) element should be checked by convertCharacterSet() or not, i.e. whether this element might be present on this dataset-level.
virtual OFCondition | convertCharacterSet (const OFString &fromCharset, const OFString &toCharset, const size_t flags=0, const OFBool updateCharset=OFFalse)
| convert all element values that are contained in this item and that are affected by SpecificCharacterSet from the given source character set to the given destination character set.
virtual OFCondition | convertCharacterSet (const OFString &toCharset, const size_t flags=0, const OFBool ignoreCharset=OFFalse)
| convert all element values that are contained in this item and that are affected by SpecificCharacterSet to the given destination character set.
virtual OFCondition | convertCharacterSet (DcmSpecificCharacterSet &converter)
| convert all element values that are contained in this item and that are affected by SpecificCharacterSet from the currently selected source character set to the currently selected destination character set.
virtual OFCondition | convertToUTF8 ()
| convert all element values that are contained in this item and that are affected by SpecificCharacterSet to UTF-8 (Unicode).
virtual void | updateSpecificCharacterSet (OFCondition &status, const DcmSpecificCharacterSet &converter)
| update the SpecificCharacterSet (0008,0005) element depending on the given parameters.
virtual OFCondition | insert (DcmElement *elem, OFBool replaceOld=OFFalse, OFBool checkInsertOrder=OFFalse)
| insert a new element into the list of elements maintained by this item.
virtual DcmElement * | getElement (const unsigned long num)
| access an element from the item.
virtual OFCondition | nextObject (DcmStack &stack, const OFBool intoSub)
| this method enables a stack based, depth-first traversal of a complete hierarchical DICOM dataset (that is, classes derived from DcmItem or DcmSequenceOfItems).
virtual DcmObject * | nextInContainer (const DcmObject *obj)
| this method is only used in container classes, that is, DcmItem and DcmSequenceOfItems.
virtual DcmElement * | remove (const unsigned long num)
| remove element from list.
virtual DcmElement * | remove (DcmObject *elem)
| remove element from list.
virtual DcmElement * | remove (const DcmTagKey &tag)
| remove element from list.
virtual OFBool | isEmpty (const OFBool normalize=OFTrue)
| check if this item is empty
virtual OFCondition | clear ()
| clear (remove) all attributes from item and delete them from memory.
virtual OFCondition | verify (const OFBool autocorrect=OFFalse)
| check the currently stored element value
virtual OFCondition | search (const DcmTagKey &xtag, DcmStack &resultStack, E_SearchMode mode=ESM_fromHere, OFBool searchIntoSub=OFTrue)
| a complex, stack-based, hierarchical search method.
virtual OFCondition | loadAllDataIntoMemory ()
| this method loads all attribute values maintained by this object and all sub-objects (in case of a container such as DcmDataset) into memory.
virtual void | compactElements (const Uint32 maxLength)
| iterate over all elements and remove those element values from memory which exceed a given length and which can be loaded from file when needed again.
virtual OFCondition | computeGroupLengthAndPadding (const E_GrpLenEncoding glenc, const E_PaddingEncoding padenc=EPD_noChange, const E_TransferSyntax xfer=EXS_Unknown, const E_EncodingType enctype=EET_ExplicitLength, const Uint32 padlen=0, const Uint32 subPadlen=0, Uint32 instanceLength=0)
| This function takes care of group length and padding elements in the current element list according to what is specified in glenc and padenc.
OFBool | tagExists (const DcmTagKey &key, OFBool searchIntoSub=OFFalse)
| check if an element with the given attribute tag exists in the dataset
OFBool | tagExistsWithValue (const DcmTagKey &key, OFBool searchIntoSub=OFFalse)
| check if an element with the given attribute tag exists in the dataset and has a non-empty value
OFCondition | findAndGetElement (const DcmTagKey &tagKey, DcmElement *&element, const OFBool searchIntoSub=OFFalse, const OFBool createCopy=OFFalse)
| find element and get a pointer to it (or copy it).
OFCondition | findAndGetElements (const DcmTagKey &tagKey, DcmStack &resultStack)
| find all elements matching a particular tag and return references to them on a stack.
OFCondition | findAndGetString (const DcmTagKey &tagKey, const char *&value, const OFBool searchIntoSub=OFFalse)
| find element and get value as a reference to a C string.
OFCondition | findAndGetString (const DcmTagKey &tagKey, const char *&value, Uint32 &length, const OFBool searchIntoSub=OFFalse)
| find element and get value as a reference to a C string.
OFCondition | findAndGetOFString (const DcmTagKey &tagKey, OFString &value, const unsigned long pos=0, const OFBool searchIntoSub=OFFalse)
| find element and get value as a C++ string (only one component).
OFCondition | findAndGetOFStringArray (const DcmTagKey &tagKey, OFString &value, const OFBool searchIntoSub=OFFalse)
| find element and get value as a C++ string (all components).
OFCondition | findAndGetUint8 (const DcmTagKey &tagKey, Uint8 &value, const unsigned long pos=0, const OFBool searchIntoSub=OFFalse)
| find element and get value as an unsigned 8-bit integer.
OFCondition | findAndGetUint8Array (const DcmTagKey &tagKey, const Uint8 *&value, unsigned long *count=NULL, const OFBool searchIntoSub=OFFalse)
| find element and get value as an array of unsigned 8-bit integers.
OFCondition | findAndGetUint16 (const DcmTagKey &tagKey, Uint16 &value, const unsigned long pos=0, const OFBool searchIntoSub=OFFalse)
| find element and get value as an unsigned 16-bit integer.
OFCondition | findAndGetUint16Array (const DcmTagKey &tagKey, const Uint16 *&value, unsigned long *count=NULL, const OFBool searchIntoSub=OFFalse)
| find element and get value as an array of unsigned 16-bit integers.
OFCondition | findAndGetSint16 (const DcmTagKey &tagKey, Sint16 &value, const unsigned long pos=0, const OFBool searchIntoSub=OFFalse)
| find element and get value as a signed 16-bit integer.
OFCondition | findAndGetSint16Array (const DcmTagKey &tagKey, const Sint16 *&value, unsigned long *count=NULL, const OFBool searchIntoSub=OFFalse)
| find element and get value as an array of signed 16-bit integers.
OFCondition | findAndGetUint32 (const DcmTagKey &tagKey, Uint32 &value, const unsigned long pos=0, const OFBool searchIntoSub=OFFalse)
| find element and get value as an unsigned 32-bit integer.
OFCondition | findAndGetUint32Array (const DcmTagKey &tagKey, const Uint32 *&value, unsigned long *count=NULL, const OFBool searchIntoSub=OFFalse)
| find element and get value as an array of unsigned 32-bit integers.
OFCondition | findAndGetSint32 (const DcmTagKey &tagKey, Sint32 &value, const unsigned long pos=0, const OFBool searchIntoSub=OFFalse)
| find element and get value as a signed 32-bit integer.
OFCondition | findAndGetSint32Array (const DcmTagKey &tagKey, const Sint32 *&value, unsigned long *count=NULL, const OFBool searchIntoSub=OFFalse)
| find element and get value as an array of signed 32-bit integers.
OFCondition | findAndGetUint64 (const DcmTagKey &tagKey, Uint64 &value, const unsigned long pos=0, const OFBool searchIntoSub=OFFalse)
| find element and get value as an unsigned 64-bit integer.
OFCondition | findAndGetUint64Array (const DcmTagKey &tagKey, const Uint64 *&value, unsigned long *count=NULL, const OFBool searchIntoSub=OFFalse)
| find element and get value as an array of unsigned 64-bit integers.
OFCondition | findAndGetSint64 (const DcmTagKey &tagKey, Sint64 &value, const unsigned long pos=0, const OFBool searchIntoSub=OFFalse)
| find element and get value as a signed 64-bit integer.
OFCondition | findAndGetSint64Array (const DcmTagKey &tagKey, const Sint64 *&value, unsigned long *count=NULL, const OFBool searchIntoSub=OFFalse)
| find element and get value as an array of signed 64-bit integers.
OFCondition | findAndGetLongInt (const DcmTagKey &tagKey, long int &value, const unsigned long pos=0, const OFBool searchIntoSub=OFFalse)
| find element and get value as a (signed) long integer.
OFCondition | findAndGetFloat32 (const DcmTagKey &tagKey, Float32 &value, const unsigned long pos=0, const OFBool searchIntoSub=OFFalse)
| find element and get value as a 32-bit floating point.
OFCondition | findAndGetFloat32Array (const DcmTagKey &tagKey, const Float32 *&value, unsigned long *count=NULL, const OFBool searchIntoSub=OFFalse)
| find element and get value as an array of 32-bit floating point values.
OFCondition | findAndGetFloat64 (const DcmTagKey &tagKey, Float64 &value, const unsigned long pos=0, const OFBool searchIntoSub=OFFalse)
| find element and get value as a 64-bit floating point.
OFCondition | findAndGetFloat64Array (const DcmTagKey &tagKey, const Float64 *&value, unsigned long *count=NULL, const OFBool searchIntoSub=OFFalse)
| find element and get value as an array of 64-bit floating point values.
OFCondition | findAndGetSequence (const DcmTagKey &seqTagKey, DcmSequenceOfItems *&sequence, const OFBool searchIntoSub=OFFalse, const OFBool createCopy=OFFalse)
| looks up and returns a given sequence.
OFCondition | findAndGetSequenceItem (const DcmTagKey &seqTagKey, DcmItem *&item, const signed long itemNum=0, const OFBool createCopy=OFFalse)
| looks up and returns a given sequence item, if it exists.
OFCondition | findOrCreateSequenceItem (const DcmTag &seqTag, DcmItem *&item, const signed long itemNum=0)
| looks up the given sequence in the current dataset and returns the given item.
OFCondition | findAndInsertCopyOfElement (const DcmTagKey &tagKey, DcmItem *destItem, const OFBool replaceOld=OFTrue)
| find element, create a copy and insert it into the given destination dataset.
OFCondition | findAndDeleteElement (const DcmTagKey &tagKey, const OFBool allOccurrences=OFFalse, const OFBool searchIntoSub=OFFalse)
| find element, remove it from the dataset and free the associated memory.
OFCondition | findAndDeleteSequenceItem (const DcmTagKey &seqTagKey, const signed long itemNum)
| looks up the given sequence in the current dataset and deletes the given item.
OFCondition | putAndInsertString (const DcmTag &tag, const char *value, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertString (const DcmTag &tag, const char *value, const Uint32 length, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertOFStringArray (const DcmTag &tag, const OFString &value, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertUint8Array (const DcmTag &tag, const Uint8 *value, const unsigned long count, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertUint16 (const DcmTag &tag, const Uint16 value, const unsigned long pos=0, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertUint16Array (const DcmTag &tag, const Uint16 *value, const unsigned long count, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertSint16 (const DcmTag &tag, const Sint16 value, const unsigned long pos=0, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertSint16Array (const DcmTag &tag, const Sint16 *value, const unsigned long count, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertUint32 (const DcmTag &tag, const Uint32 value, const unsigned long pos=0, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertUint32Array (const DcmTag &tag, const Uint32 *value, const unsigned long count, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertSint32 (const DcmTag &tag, const Sint32 value, const unsigned long pos=0, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertSint32Array (const DcmTag &tag, const Sint32 *value, const unsigned long count, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertUint64 (const DcmTag &tag, const Uint64 value, const unsigned long pos=0, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertUint64Array (const DcmTag &tag, const Uint64 *value, const unsigned long count, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertSint64 (const DcmTag &tag, const Sint64 value, const unsigned long pos=0, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertSint64Array (const DcmTag &tag, const Sint64 *value, const unsigned long count, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertFloat32 (const DcmTag &tag, const Float32 value, const unsigned long pos=0, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertFloat32Array (const DcmTag &tag, const Float32 *value, const unsigned long count, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertFloat64 (const DcmTag &tag, const Float64 value, const unsigned long pos=0, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertFloat64Array (const DcmTag &tag, const Float64 *value, const unsigned long count, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | putAndInsertTagKey (const DcmTag &tag, const DcmTagKey &value, const unsigned long pos=0, const OFBool replaceOld=OFTrue)
| create a new element, put specified value to it and insert the element into the dataset/item.
OFCondition | insertEmptyElement (const DcmTag &tag, const OFBool replaceOld=OFTrue)
| create a new element (with no value) and insert it into the dataset/item.
OFCondition | insertSequenceItem (const DcmTag &seqTag, DcmItem *item, const signed long itemNum=-2)
| looks up the given sequence in the current dataset and inserts the given item.
Public Member Functions inherited from DcmObject
| DcmObject (const DcmTag &tag, const Uint32 len=0)
| constructor.
| DcmObject (const DcmObject &obj)
| copy constructor
virtual | ~DcmObject ()
| destructor
DcmObject & | operator= (const DcmObject &obj)
| copy assignment operator
DcmEVR | getVR () const
| return the value representation assigned to this object.
OFBool | isaString () const
| check if this element is a string type, based on the VR.
virtual OFBool | isElement () const
| check if this element can be safely casted to DcmElement
E_TransferState | transferState () const
| return the current transfer (read/write) state of this object.
DcmItem * | getRootItem ()
| get root dataset/item (top-level) that contains this object.
DcmObject * | getParent ()
| get parent of this object.
const DcmObject * | getParent () const
| get parent of this object.
void | setParent (DcmObject *parent)
| set parent of this object.
Uint16 | getGTag () const
| return the group number of the attribute tag for this object
Uint16 | getETag () const
| return the element number of the attribute tag for this object
const DcmTag & | getTag () const
| return const reference to the attribute tag for this object
void | setGTag (Uint16 gtag)
| assign group tag (but not element tag) of the attribute tag for this object.
virtual OFCondition | setVR (DcmEVR vr)
| assign a new Value Representation (VR) to this object.
virtual OFBool | isSignable () const
| returns true if the current object may be included in a digital signature
Uint32 | getLengthField () const
| return the current value of the Length field (which is different from the functionality of the public getLength() method).

## Private Member Functions
void | setPreamble ()
| initialize the preamble buffer with 128 zero bytes followed by "DICM"
OFBool | checkAndReadPreamble (DcmInputStream &inStream, E_TransferSyntax &newxfer)
| check if the next 132 bytes in the input stream are a preamble followed by the DICOM "magic word" DICM.
OFBool | nextTagIsMeta (DcmInputStream &inStream)
| peeks into the input stream and checks whether the next element is group 0002, i.e.
OFCondition | readGroupLength (DcmInputStream &inStream, const E_TransferSyntax xfer, const DcmTagKey &xtag, const E_GrpLenEncoding glenc, Uint32 &headerLen, Uint32 &bytesRead, const Uint32 maxReadLength=DCM_MaxReadLength)
| read meta-header group length element which is important because it tells us where to switch from meta-header transfer syntax to dataset transfer syntax.

## Private Attributes
char | filePreamble [DCM_PreambleLen+DCM_MagicLen]
| buffer for 132 byte DICOM file preamble
OFBool | preambleUsed
| true if the preamble was read from stream
E_TransferState | fPreambleTransferState
| transfer state of the preamble
E_TransferSyntax | Xfer
| transfer syntax in which the meta-header was read

## Additional Inherited Members
Static Public Member Functions inherited from DcmItem
static DcmElement * | newDicomElement (const DcmTagKey &tag, const char *privateCreator=NULL)
| creates new DICOM element from given attribute tag.
static OFCondition | newDicomElement (DcmElement *&newElement, const DcmTagKey &tag, const char *privateCreator=NULL)
| creates new DICOM element from given attribute tag.
static OFCondition | newDicomElementWithVR (DcmElement *&newElement, const DcmTag &tag)
| creates new DICOM element from given attribute tag and VR.
Protected Member Functions inherited from DcmItem
OFCondition | readTagAndLength (DcmInputStream &inStream, const E_TransferSyntax xfer, DcmTag &tag, Uint32 &length, Uint32 &bytesRead)
| This function reads tag and length information from inStream and returns this information to the caller.
OFCondition | readSubElement (DcmInputStream &inStream, DcmTag &newTag, const Uint32 newLength, const E_TransferSyntax xfer, const E_GrpLenEncoding glenc, const Uint32 maxReadLength=DCM_MaxReadLength)
| This function creates a new DcmElement object on the basis of the newTag and newLength information which was passed, inserts this new element into elementList, reads the actual data value which belongs to this element (attribute) from the inStream and also assigns this information to the object which was created at the beginning.
E_TransferSyntax | checkTransferSyntax (DcmInputStream &inStream)
| This function reads the first 6 bytes from the input stream and determines the transfer syntax which was used to code the information in the stream.
OFBool | checkAndUpdateVR (DcmItem &item, DcmTag &tag)
| check whether the given tag requires some special handling regarding the VR (i.e. in case it is undefined and multiple values are possible).
Protected Member Functions inherited from DcmObject
void | printNestingLevel (STD_NAMESPACE ostream &out, const size_t flags, const int level)
| print line indentation, e.g. a couple of spaces for each nesting level.
void | printInfoLineStart (STD_NAMESPACE ostream &out, const size_t flags, const int level, DcmTag *tag=NULL)
| print beginning of the info line.
void | printInfoLineEnd (STD_NAMESPACE ostream &out, const size_t flags, const unsigned long printedLength=0xffffffff, DcmTag *tag=NULL)
| print end of the info line.
virtual void | printInfoLine (STD_NAMESPACE ostream &out, const size_t flags, const int level=0, const char *info=NULL, DcmTag *tag=NULL, const OFBool isInfo=OFTrue)
| print given text with element information.
virtual OFCondition | writeTagAndLength (DcmOutputStream &outStream, const E_TransferSyntax oxfer, Uint32 &writtenBytes) const
| write tag, VR and length field to the given output stream
virtual Uint32 | getTagAndLengthSize (const E_TransferSyntax oxfer) const
| return the number of bytes needed to serialize the tag, VR and length information of the current object using the given transfer syntax.
const char * | getTagName ()
| return the DICOM attribute tag name for this object.
void | setTagVR (DcmEVR vr)
| set the VR for this attribute
E_TransferState | getTransferState () const
| return the current transfer state of this object during serialization/deserialization
void | setTransferState (E_TransferState newState)
| set the current transfer state of this object during serialization/deserialization
Uint32 | getTransferredBytes () const
| return the number of transferred bytes for this object during serialization/deserialization
void | setTransferredBytes (Uint32 val)
| set the number of transferred bytes for this object during serialization/deserialization
void | incTransferredBytes (Uint32 val)
| add to the number of transferred bytes for this object during serialization/deserialization
void | setLengthField (Uint32 val)
| set the current value of the Length field
Static Protected Member Functions inherited from DcmItem
static OFCondition | newDicomElement (DcmElement *&newElement, DcmTag &tag, const Uint32 length, DcmPrivateTagCache *privateCreatorCache, OFBool &readAsUN)
| creates new DICOM element from given attribute tag.
Static Protected Member Functions inherited from DcmObject
static OFCondition | writeTag (DcmOutputStream &outStream, const DcmTag &tag, const E_TransferSyntax oxfer)
| static helper function that writes a given attribute tag to a binary output stream using the byte order indicated by the transfer syntax.
Protected Attributes inherited from DcmItem
DcmList * | elementList
| the list of elements maintained by this object
OFBool | lastElementComplete
| flag used during suspended I/O.
offile_off_t | fStartPosition
| used during reading.
Protected Attributes inherited from DcmObject
OFCondition | errorFlag
| error flag for this object.

## Detailed Description

a class representing the DICOM file meta information header

## Constructor & Destructor Documentation

## ◆ DcmMetaInfo()

DcmMetaInfo::DcmMetaInfo | ( | const DcmMetaInfo & | old | ) |

copy constructor

Parameters

  old | item to be copied

References DcmMetaInfo().

## Member Function Documentation

## ◆ calcElementLength()

virtual Uint32 DcmMetaInfo::calcElementLength | ( | const E_TransferSyntax | xfer,
|  | const E_EncodingType | enctype )
| virtual

calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.

For elements, the length includes the length of the tag, length field, VR field and the value itself, for items and sequences it returns the length of the complete item or sequence including delimitation tags if applicable.

Warning
  Since calcElementLength() returns a 32 bit integer, an overflow during calculation is possible for some derived classes that actually represent a compound value (e.g. items like DcmPixelItem). Such overflows will be detected, in which case the maximum possible value will be returned instead, coinciding with DCM_UndefinedLength.
  The implementation in DcmPixelData may return zero if no conforming representation exists and set the EC_RepresentationNotFound error flag to indicated it.
  When calculation the length of a sequence or an item containing multiple attributes, the implementation may return DCM_UndefinedLength to indicate a value that can not be encoded as a 32 bit length field. It will even do so if "dcmWriteOversizedSeqsAndItemsUndefined" is disabled, but then also set the EC_SeqOrItemContentOverflow error flag (inside getLength()) to indicated it.

Note
  Just check for zero or DCM_UndefinedLength return value and then have a look at the error flag in either case.

Parameters

  xfer | transfer syntax for length calculation
  enctype | sequence encoding type for length calculation

Returns
  length of DICOM element

Reimplemented from DcmItem.

## ◆ checkAndReadPreamble()

OFBool DcmMetaInfo::checkAndReadPreamble | ( | DcmInputStream & | inStream,
|  | E_TransferSyntax & | newxfer )
| private

check if the next 132 bytes in the input stream are a preamble followed by the DICOM "magic word" DICM.

If so, try to determine the transfer syntax of the meta-header and return in parameter newxfer. If not, reset stream to start position.

Parameters

  inStream | input stream, should be at start position
  newxfer | as input parameter contains the expected transfer syntax, as output parameter returns the real transfer syntax of the meta-header as determined heuristically

Returns
  true if meta-header found and read, false otherwise

## ◆ clone()

virtual DcmObject * DcmMetaInfo::clone | ( |  | ) | const
| inlinevirtual

clone method

Returns
  deep copy of this object

Reimplemented from DcmItem.

References DcmMetaInfo(), and DcmObject::DcmObject().

## ◆ copyFrom()

virtual OFCondition DcmMetaInfo::copyFrom | ( | const DcmObject & | rhs | ) |
| virtual

Virtual object copying.

This method can be used for DcmObject and derived classes to get a deep copy of an object. Internally the assignment operator is called if the given DcmObject parameter is of the same type as "this" object instance. If not, an error is returned. This function permits copying an object by value in a virtual way which therefore is different to just calling the assignment operator of DcmElement which could result in slicing the object.

Parameters

  rhs | - [in] The instance to copy from. Has to be of the same class type as "this" object

Returns
  EC_Normal if copying was successful, error otherwise

Reimplemented from DcmItem.

References DcmObject::DcmObject().

## ◆ getOriginalXfer()

E_TransferSyntax DcmMetaInfo::getOriginalXfer | ( |  | ) | const

return the transfer syntax in which this dataset was originally read.

Returns
  transfer syntax in which this dataset was originally read, EXS_Unknown if the dataset was created in memory

## ◆ getPreamble()

virtual const char * DcmMetaInfo::getPreamble | ( |  | ) | const
| virtual

access the file preamble after reading a DICOM file.

Returns
  pointer to a 132-byte array containing the DICOM file preamble (i.e. the unused first 128 bytes of a DICOM file) and the magic word ("DICM"). If no DICOM fileformat was loaded, array will be zeroed.

## ◆ ident()

virtual DcmEVR DcmMetaInfo::ident | ( |  | ) | const
| virtual

get type identifier

Returns
  type identifier of this class (EVR_item)

Reimplemented from DcmItem.

## ◆ loadFile()

virtual OFCondition DcmMetaInfo::loadFile | ( | const OFFilename & | fileName,
|  | const E_TransferSyntax | readXfer = EXS_Unknown,
|  | const E_GrpLenEncoding | groupLength = EGL_noChange,
|  | const Uint32 | maxReadLength = DCM_MaxReadLength )
| virtual

load object from a DICOM file.

If the file preamble is missing, an error is returned.

Parameters

  fileName | name of the file to load (may contain wide chars if support enabled). Since there are various constructors for the OFFilename class, a "char *", "OFString" or "wchar_t *" can also be passed directly to this parameter.
  readXfer | transfer syntax used to read the data (auto detection if EXS_Unknown)
  groupLength | flag, specifying how to handle the group length tags
  maxReadLength | maximum number of bytes to be read for an element value. Element values with a larger size are not loaded until their value is retrieved (with getXXX()) or loadAllDataIntoMemory() is called.

Returns
  status, EC_Normal if successful, an error code otherwise

References EGL_noChange, and EXS_Unknown.

## ◆ nextTagIsMeta()

OFBool DcmMetaInfo::nextTagIsMeta | ( | DcmInputStream & | inStream | ) |
| private

peeks into the input stream and checks whether the next element is group 0002, i.e.

belongs to the meta-header

Parameters

  inStream | input stream

Returns
  true if next element is part of meta-header, false otherwise

## ◆ operator=()

DcmMetaInfo & DcmMetaInfo::operator= | ( | const DcmMetaInfo & | obj | ) |

assignment operator.

Parameters

  obj | the metainfo to be copied

Returns
  reference to this object

References DcmMetaInfo().

## ◆ print()

virtual void DcmMetaInfo::print | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = 0,
|  | const int | level = 0,
|  | const char * | pixelFileName = NULL,
|  | size_t * | pixelCounter = NULL )
| virtual

print meta information header to a stream

Parameters

  out | output stream
  flags | optional flag used to customize the output (see DCMTypes::PF_xxx)
  level | current level of nested items. Used for indentation.
  pixelFileName | not used
  pixelCounter | not used

Reimplemented from DcmItem.

## ◆ read()

virtual OFCondition DcmMetaInfo::read | ( | DcmInputStream & | inStream,
|  | const E_TransferSyntax | xfer = EXS_Unknown,
|  | const E_GrpLenEncoding | glenc = EGL_noChange,
|  | const Uint32 | maxReadLength = DCM_MaxReadLength )
| virtual

read object from a stream.

Parameters

  inStream | DICOM input stream
  xfer | transfer syntax to use when parsing. EXS_Unknown will lead to reading the preamble (if any) and parsing metaheader using detected transfer syntax, usually Explicit VR Little Endian.
  glenc | handling of group length parameters
  maxReadLength | attribute values larger than this value are skipped while parsing and read later upon first access if the stream type supports this.

Returns
  EC_Normal if successful, an error code otherwise

Reimplemented from DcmItem.

References EGL_noChange, and EXS_Unknown.

## ◆ readGroupLength()

OFCondition DcmMetaInfo::readGroupLength | ( | DcmInputStream & | inStream,
|  | const E_TransferSyntax | xfer,
|  | const DcmTagKey & | xtag,
|  | const E_GrpLenEncoding | glenc,
|  | Uint32 & | headerLen,
|  | Uint32 & | bytesRead,
|  | const Uint32 | maxReadLength = DCM_MaxReadLength )
| private

read meta-header group length element which is important because it tells us where to switch from meta-header transfer syntax to dataset transfer syntax.

Insert element into dataset

Parameters

  inStream | input stream
  xfer | transfer syntax of meta-header
  xtag | attribute tag for group length
  glenc | handling of group length encoding element in dataset
  headerLen | output parameter; length of meta-header as encoded in group length element
  bytesRead | output parameter; number of bytes read when reading group length (for counting the remaining number of meta-header bytes)
  maxReadLength | max read length for elements

Returns
  EC_Normal if successful, an error code otherwise

## ◆ removeInvalidGroups()

virtual void DcmMetaInfo::removeInvalidGroups | ( |  | ) |
| virtual

remove all elements with an invalid group number, i.e.

everything but 0x0002

## ◆ transferEnd()

virtual void DcmMetaInfo::transferEnd | ( |  | ) |
| virtual

finalize the transfer state of this object.

This method must be called when reading/writing this object from/to a stream has been completed.

Reimplemented from DcmItem.

## ◆ transferInit()

virtual void DcmMetaInfo::transferInit | ( |  | ) |
| virtual

initialize the transfer state of this object.

This method must be called before this object is written to a stream or read (parsed) from a stream.

Reimplemented from DcmItem.

## ◆ write()

virtual OFCondition DcmMetaInfo::write | ( | DcmOutputStream & | outStream,
|  | const E_TransferSyntax | oxfer,
|  | const E_EncodingType | enctype,
|  | DcmWriteCache * | wcache )
| virtual

write meta information header to a stream

Parameters

  outStream | DICOM output stream
  oxfer | output transfer syntax
  enctype | encoding types (undefined or explicit length)
  wcache | pointer to write cache object, may be NULL

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmItem.

## ◆ writeJson()

virtual OFCondition DcmMetaInfo::writeJson | ( | STD_NAMESPACE ostream & | out,
|  | DcmJsonFormat & | format )
| virtual

write object in JSON format

Parameters

  out | output stream to which the JSON document is written
  format | used to format and customize the output

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmItem.

## ◆ writeXML()

virtual OFCondition DcmMetaInfo::writeXML | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = 0 )
| virtual

write object in XML format

Parameters

  out | output stream to which the XML document is written
  flags | optional flag used to customize the output (see DCMTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmItem.

The documentation for this class was generated from the following file:

- dcmdata/include/dcmtk/dcmdata/dcmetinf.h

Generated on for DCMTK Version 3.7.0 by Doxygen 1.16.1